﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace PPTE
{
    public partial class Form1 : Form
    {
        private bool pokedataloaded;
        private NarcReader datanr;
        private NarcReader pokenr;
        private byte[] currenttrainer;
        private byte[,] currentpokes;
        private byte currenttype;
        private int oldsize;

        public Form1()
        {
            InitializeComponent();

            object[] itm = new object[Item1.Items.Count];
            Item1.Items.CopyTo(itm, 0);

            Item2.Items.AddRange(itm);
            Item3.Items.AddRange(itm);
            Item4.Items.AddRange(itm);
            PItem1.Items.AddRange(itm);
            PItem2.Items.AddRange(itm);
            PItem3.Items.AddRange(itm);
            PItem4.Items.AddRange(itm);
            PItem5.Items.AddRange(itm);
            PItem6.Items.AddRange(itm);

            object[] pkmn = new object[Species1.Items.Count];
            Species1.Items.CopyTo(pkmn, 0);

            Species2.Items.AddRange(pkmn);
            Species3.Items.AddRange(pkmn);
            Species4.Items.AddRange(pkmn);
            Species5.Items.AddRange(pkmn);
            Species6.Items.AddRange(pkmn);

            object[] atk = new object[Attack11.Items.Count];
            Attack11.Items.CopyTo(atk, 0);

            Attack12.Items.AddRange(atk);
            Attack13.Items.AddRange(atk);
            Attack14.Items.AddRange(atk);
            Attack21.Items.AddRange(atk);
            Attack22.Items.AddRange(atk);
            Attack23.Items.AddRange(atk);
            Attack24.Items.AddRange(atk);
            Attack31.Items.AddRange(atk);
            Attack32.Items.AddRange(atk);
            Attack33.Items.AddRange(atk);
            Attack34.Items.AddRange(atk);
            Attack41.Items.AddRange(atk);
            Attack42.Items.AddRange(atk);
            Attack43.Items.AddRange(atk);
            Attack44.Items.AddRange(atk);
            Attack51.Items.AddRange(atk);
            Attack52.Items.AddRange(atk);
            Attack53.Items.AddRange(atk);
            Attack54.Items.AddRange(atk);
            Attack61.Items.AddRange(atk);
            Attack62.Items.AddRange(atk);
            Attack63.Items.AddRange(atk);
            Attack64.Items.AddRange(atk);
        }

        private string ShowOpenDialog(string Title, string Filter)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            dialog.Title = Title;
            dialog.Filter = Filter;

            if (dialog.ShowDialog() == DialogResult.OK)
            {
                return dialog.FileName;
            }
            else
            {
                return "";
            }
        }

        private void loadTrainerDataToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.TrainerID.Items.Clear();
            string filename = ShowOpenDialog("Open trdata.narc file", "Nitro Archive Files (*.narc)|*.narc");

            if (!filename.Equals(""))
            {
                this.datanr = new NarcReader(filename);

                for (int i = 0; i < this.datanr.Entries; i++)
                {
                    this.TrainerID.Items.Add(string.Format("Trainer {0:000}", i));
                }

                this.loadTrainerPokemonToolStripMenuItem.Enabled = true;
            }
        }

        private void loadTrainerPokemonToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string filename = ShowOpenDialog("Open trpoke.narc file", "Nitro Archive Files (*.narc)|*.narc");

            if (!filename.Equals(""))
            {
                this.pokenr = new NarcReader(filename);
                this.TrainerID.Enabled = this.Game.SelectedIndex >= 0;
                pokedataloaded = true;
            }

        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void saveAllToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveAll_Click(sender, e);
        }

        private void TrainerID_SelectedIndexChanged(object sender, EventArgs e)
        {
            int index = this.TrainerID.Items.IndexOf(this.TrainerID.Text);
            currenttrainer = new byte[0x14];
            currentpokes = new byte[6, 0x12];
            this.datanr.OpenEntry(index);
            this.datanr.fs.Seek(0, SeekOrigin.Current);
            BinaryReader datareader = new BinaryReader(this.datanr.fs);

            for (int i = 0; i < 0x14; i++)
            {
                try
                {
                    currenttrainer[i] = datareader.ReadByte();
                }
                catch
                {
                    // Just in case an EndOfStream exception is thrown
                }
            }

            this.datanr.fs.Close();

            currenttype = currenttrainer[0];
            this.Type.Enabled = true;
            this.Type.Value = currenttype;
            
            this.TrainerClass.Enabled = true;
            this.TrainerClass.SelectedIndex = (int)(currenttrainer[1]);
            this.NumberPokemon.Enabled = true;
            this.NumberPokemon.Value = (int)(currenttrainer[3]);

            if ((int)(currenttrainer[3]) >= 2)
            {
                this.IsDoubleBattle.Enabled = true;
                this.IsDoubleBattle.Checked = currenttrainer[0x10] != 0;
            }
            else
            {
                this.IsDoubleBattle.Enabled = false;
                this.IsDoubleBattle.Checked = false;
            }

            this.Item1.Enabled = true;
            this.Item2.Enabled = true;
            this.Item3.Enabled = true;
            this.Item4.Enabled = true;
            this.Item1.SelectedIndex = (int)(currenttrainer[4]) + (((int)(currenttrainer[5])) << 8);
            this.Item2.SelectedIndex = (int)(currenttrainer[6]) + (((int)(currenttrainer[7])) << 8);
            this.Item3.SelectedIndex = (int)(currenttrainer[8]) + (((int)(currenttrainer[9])) << 8);
            this.Item4.SelectedIndex = (int)(currenttrainer[10]) + (((int)(currenttrainer[11])) << 8);

            if (pokedataloaded)
            {
                if (this.TrainerID.SelectedIndex > 0)
                {
                    this.SaveAll.Enabled = true;
                    this.saveAllToolStripMenuItem.Enabled = true;
                }
                else
                {
                    this.SaveAll.Enabled = false;
                    this.saveAllToolStripMenuItem.Enabled = false;
                }

                this.pokenr.OpenEntry(index);
                int size = this.pokenr.fe[index].Size;
                this.pokenr.fs.Seek(0, SeekOrigin.Current);
                BinaryReader pokereader = new BinaryReader(this.pokenr.fs);
                int datasize = 0;

                switch ((int)this.Type.Value)
                {
                    case 0:
                        datasize = 0x6;
                        break;

                    case 1:
                        datasize = 0xE;
                        break;

                    case 2:
                        datasize = 0x8;
                        break;

                    case 3:
                        datasize = 0x10;
                        break;
                }

                if (this.Game.SelectedIndex == 1) // Platinum
                {
                    datasize += 2;
                }

                for (int i = 0; i < this.NumberPokemon.Value; i++)
                {
                    for (int j = 0; j < datasize; j++)
                    {
                        oldsize = (int)this.NumberPokemon.Value * datasize;

                        try
                        {
                            currentpokes[i, j] = pokereader.ReadByte();
                        }

                        catch
                        {
                        }

                    }
                }

                this.pokenr.fs.Close();
                GetCurrentPokes();
            }
        }

        private void aboutToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Project Pokemon's Trainer Editor\nProgrammed in C# by SCV\nContact: scvgeo@gmail.com\nThanks to HackMew for the great GUI and other code improvements", "About");
        }

        private void GetCurrentPokes()
        {
            this.Attack11.Enabled = false;
            this.Attack12.Enabled = false;
            this.Attack13.Enabled = false;
            this.Attack14.Enabled = false;
            this.Attack21.Enabled = false;
            this.Attack22.Enabled = false;
            this.Attack23.Enabled = false;
            this.Attack24.Enabled = false;
            this.Attack31.Enabled = false;
            this.Attack32.Enabled = false;
            this.Attack33.Enabled = false;
            this.Attack34.Enabled = false;
            this.Attack41.Enabled = false;
            this.Attack42.Enabled = false;
            this.Attack43.Enabled = false;
            this.Attack44.Enabled = false;
            this.Attack51.Enabled = false;
            this.Attack52.Enabled = false;
            this.Attack53.Enabled = false;
            this.Attack54.Enabled = false;
            this.Attack61.Enabled = false;
            this.Attack62.Enabled = false;
            this.Attack63.Enabled = false;
            this.Attack64.Enabled = false;
            
            this.Level1.Enabled = false;
            this.Level2.Enabled = false;
            this.Level3.Enabled = false;
            this.Level4.Enabled = false;
            this.Level5.Enabled = false;
            this.Level6.Enabled = false;
            
            this.PItem1.Enabled = false;
            this.PItem2.Enabled = false;
            this.PItem3.Enabled = false;
            this.PItem4.Enabled = false;
            this.PItem5.Enabled = false;
            this.PItem6.Enabled = false;

            this.Species1.Enabled = false;
            this.Species2.Enabled = false;
            this.Species3.Enabled = false;
            this.Species4.Enabled = false;
            this.Species5.Enabled = false;
            this.Species6.Enabled = false;
            
            this.PForm1.Enabled = false;
            this.PForm2.Enabled = false;
            this.PForm3.Enabled = false;
            this.PForm4.Enabled = false;
            this.PForm4.Enabled = false;
            this.PForm5.Enabled = false;
            this.PForm6.Enabled = false;
            
            this.Attack11.SelectedIndex = 0;
            this.Attack12.SelectedIndex = 0;
            this.Attack13.SelectedIndex = 0;
            this.Attack14.SelectedIndex = 0;
            this.Attack21.SelectedIndex = 0;
            this.Attack22.SelectedIndex = 0;
            this.Attack23.SelectedIndex = 0;
            this.Attack24.SelectedIndex = 0;
            this.Attack31.SelectedIndex = 0;
            this.Attack32.SelectedIndex = 0;
            this.Attack33.SelectedIndex = 0;
            this.Attack34.SelectedIndex = 0;
            this.Attack41.SelectedIndex = 0;
            this.Attack42.SelectedIndex = 0;
            this.Attack43.SelectedIndex = 0;
            this.Attack44.SelectedIndex = 0;
            this.Attack51.SelectedIndex = 0;
            this.Attack52.SelectedIndex = 0;
            this.Attack53.SelectedIndex = 0;
            this.Attack54.SelectedIndex = 0;
            this.Attack61.SelectedIndex = 0;
            this.Attack62.SelectedIndex = 0;
            this.Attack63.SelectedIndex = 0;
            this.Attack64.SelectedIndex = 0;
            
            this.Level1.Value = 0;
            this.Level2.Value = 0;
            this.Level3.Value = 0;
            this.Level4.Value = 0;
            this.Level5.Value = 0;
            this.Level6.Value = 0;
            
            this.PItem1.SelectedIndex = 0;
            this.PItem2.SelectedIndex = 0;
            this.PItem3.SelectedIndex = 0;
            this.PItem4.SelectedIndex = 0;
            this.PItem5.SelectedIndex = 0;
            this.PItem6.SelectedIndex = 0;
            
            this.Species1.SelectedIndex = 0;
            this.Species2.SelectedIndex = 0;
            this.Species3.SelectedIndex = 0;
            this.Species4.SelectedIndex = 0;
            this.Species5.SelectedIndex = 0;
            this.Species6.SelectedIndex = 0;

            this.PForm1.Items.Clear();
            this.PForm2.Items.Clear();
            this.PForm3.Items.Clear();
            this.PForm4.Items.Clear();
            this.PForm5.Items.Clear();
            this.PForm6.Items.Clear();

            if (this.NumberPokemon.Value >= 1)
            {
                this.Level1.Enabled = true;
                this.Level1.Value = (int)(currentpokes[0, 2]);
                this.Species1.Enabled = true;
                this.Species1.SelectedIndex = (int)(currentpokes[0, 4]) + (((int)(currentpokes[0, 5] & 1)) << 8);
                AddPokemonForms(0, this.Species1.SelectedIndex, this.PForm1, currentpokes[0, 5] >> 2);

                if ((int)this.Type.Value % 2 == 1)
                {
                    this.Attack11.Enabled = true;
                    this.Attack12.Enabled = true;
                    this.Attack13.Enabled = true;
                    this.Attack14.Enabled = true;
                    this.Attack11.SelectedIndex = (int)(currentpokes[0, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[0, 7 + (int)this.Type.Value - 1])) << 8);
                    this.Attack12.SelectedIndex = (int)(currentpokes[0, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[0, 9 + (int)this.Type.Value - 1])) << 8);
                    this.Attack13.SelectedIndex = (int)(currentpokes[0, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[0, 11 + (int)this.Type.Value - 1])) << 8);
                    this.Attack14.SelectedIndex = (int)(currentpokes[0, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[0, 13 + (int)this.Type.Value - 1])) << 8);

                    if ((int)this.Type.Value == 3)
                    {
                        this.PItem1.Enabled = true;
                        this.PItem1.SelectedIndex = (int)(currentpokes[0, 6]) + (((int)(currentpokes[0, 7])) << 8);
                    }
                    
                }
                else if ((int)this.Type.Value == 2)
                {
                    this.PItem1.Enabled = true;
                    this.PItem1.SelectedIndex = (int)(currentpokes[0, 6]) + (((int)(currentpokes[0, 7])) << 8);
                }

                if (this.NumberPokemon.Value >= 2)
                {
                    this.Level2.Enabled = true;
                    this.Level2.Value = (int)(currentpokes[1, 2]);
                    this.Species2.Enabled = true;
                    this.Species2.SelectedIndex = (int)(currentpokes[1, 4]) + (((int)(currentpokes[1, 5] & 1)) << 8);
                    AddPokemonForms(1, this.Species2.SelectedIndex, this.PForm2, currentpokes[1, 5] >> 2);

                    if ((int)this.Type.Value % 2 == 1)
                    {
                        this.Attack21.Enabled = true;
                        this.Attack22.Enabled = true;
                        this.Attack23.Enabled = true;
                        this.Attack24.Enabled = true;
                        this.Attack21.SelectedIndex = (int)(currentpokes[1, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[1, 7 + (int)this.Type.Value - 1])) << 8);
                        this.Attack22.SelectedIndex = (int)(currentpokes[1, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[1, 9 + (int)this.Type.Value - 1])) << 8);
                        this.Attack23.SelectedIndex = (int)(currentpokes[1, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[1, 11 + (int)this.Type.Value - 1])) << 8);
                        this.Attack24.SelectedIndex = (int)(currentpokes[1, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[1, 13 + (int)this.Type.Value - 1])) << 8);

                        if ((int)this.Type.Value == 3)
                        {
                            this.PItem2.Enabled = true;
                            this.PItem2.SelectedIndex = (int)(currentpokes[1, 6]) + (((int)(currentpokes[1, 7])) << 8);
                        }

                    }
                    else if ((int)this.Type.Value == 2)
                    {
                        this.PItem2.Enabled = true;
                        this.PItem2.SelectedIndex = (int)(currentpokes[1, 6]) + (((int)(currentpokes[1, 7])) << 8);
                    }

                    if (this.NumberPokemon.Value >= 3)
                    {
                        this.Level3.Enabled = true;
                        this.Level3.Value = currentpokes[2, 2];
                        this.Species3.Enabled = true;
                        this.Species3.SelectedIndex = (int)(currentpokes[2, 4]) + (((int)(currentpokes[2, 5] & 1)) << 8);
                        AddPokemonForms(2, this.Species3.SelectedIndex, this.PForm3, currentpokes[2, 5] >> 2);

                        if ((int)this.Type.Value % 2 == 1)
                        {
                            this.Attack31.Enabled = true;
                            this.Attack32.Enabled = true;
                            this.Attack33.Enabled = true;
                            this.Attack34.Enabled = true;
                            this.Attack31.SelectedIndex = (int)(currentpokes[2, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[2, 7 + (int)this.Type.Value - 1])) << 8);
                            this.Attack32.SelectedIndex = (int)(currentpokes[2, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[2, 9 + (int)this.Type.Value - 1])) << 8);
                            this.Attack33.SelectedIndex = (int)(currentpokes[2, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[2, 11 + (int)this.Type.Value - 1])) << 8);
                            this.Attack34.SelectedIndex = (int)(currentpokes[2, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[2, 13 + (int)this.Type.Value - 1])) << 8);

                            if ((int)this.Type.Value == 3)
                            {
                                this.PItem3.Enabled = true;
                                this.PItem3.SelectedIndex = (int)(currentpokes[2, 6]) + (((int)(currentpokes[2, 7])) << 8);
                            }

                        }
                        else if ((int)this.Type.Value == 2)
                        {
                            this.PItem3.Enabled = true;
                            this.PItem3.SelectedIndex = (int)(currentpokes[2, 6]) + (((int)(currentpokes[2, 7])) << 8);
                        }

                        if (this.NumberPokemon.Value >= 4)
                        {
                            this.Level4.Enabled = true;
                            this.Level4.Value = currentpokes[3, 2];
                            this.Species4.Enabled = true;
                            this.Species4.SelectedIndex = (int)(currentpokes[3, 4]) + (((int)(currentpokes[3, 5] & 1)) << 8);
                            AddPokemonForms(3, this.Species4.SelectedIndex, this.PForm4, currentpokes[3, 5] >> 2);

                            if ((int)this.Type.Value % 2 == 1)
                            {
                                this.Attack41.Enabled = true;
                                this.Attack42.Enabled = true;
                                this.Attack43.Enabled = true;
                                this.Attack44.Enabled = true;
                                this.Attack41.SelectedIndex = (int)(currentpokes[3, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[3, 7 + (int)this.Type.Value - 1])) << 8);
                                this.Attack42.SelectedIndex = (int)(currentpokes[3, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[3, 9 + (int)this.Type.Value - 1])) << 8);
                                this.Attack43.SelectedIndex = (int)(currentpokes[3, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[3, 11 + (int)this.Type.Value - 1])) << 8);
                                this.Attack44.SelectedIndex = (int)(currentpokes[3, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[3, 13 + (int)this.Type.Value - 1])) << 8);

                                if ((int)this.Type.Value == 3)
                                {
                                    this.PItem4.Enabled = true;
                                    this.PItem4.SelectedIndex = (int)(currentpokes[3, 6]) + (((int)(currentpokes[3, 7])) << 8);
                                }

                            }
                            else if ((int)this.Type.Value == 2)
                            {
                                this.PItem4.Enabled = true;
                                this.PItem4.SelectedIndex = (int)(currentpokes[3, 6]) + (((int)(currentpokes[3, 7])) << 8);
                            }

                            if (this.NumberPokemon.Value >= 5)
                            {
                                this.Level5.Enabled = true;
                                this.Level5.Value = currentpokes[4, 2];
                                this.Species5.Enabled = true;
                                this.Species5.SelectedIndex = (int)(currentpokes[4, 4]) + (((int)(currentpokes[4, 5] & 1)) << 8);
                                AddPokemonForms(4, this.Species5.SelectedIndex, this.PForm5, currentpokes[4, 5] >> 2);

                                if ((int)this.Type.Value % 2 == 1)
                                {
                                    this.Attack51.Enabled = true;
                                    this.Attack52.Enabled = true;
                                    this.Attack53.Enabled = true;
                                    this.Attack54.Enabled = true;
                                    this.Attack51.SelectedIndex = (int)(currentpokes[4, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[4, 7 + (int)this.Type.Value - 1])) << 8);
                                    this.Attack52.SelectedIndex = (int)(currentpokes[4, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[4, 9 + (int)this.Type.Value - 1])) << 8);
                                    this.Attack53.SelectedIndex = (int)(currentpokes[4, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[4, 11 + (int)this.Type.Value - 1])) << 8);
                                    this.Attack54.SelectedIndex = (int)(currentpokes[4, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[4, 13 + (int)this.Type.Value - 1])) << 8);

                                    if ((int)this.Type.Value == 3)
                                    {
                                        this.PItem5.Enabled = true;
                                        this.PItem5.SelectedIndex = (int)(currentpokes[4, 6]) + (((int)(currentpokes[4, 7])) << 8);
                                    }

                                }
                                else if ((int)this.Type.Value == 2)
                                {
                                    this.PItem5.Enabled = true;
                                    this.PItem5.SelectedIndex = (int)(currentpokes[4, 6]) + (((int)(currentpokes[4, 7])) << 8);
                                }

                                if (this.NumberPokemon.Value == 6)
                                {
                                    this.Level6.Enabled = true;
                                    this.Level6.Value = currentpokes[5, 2];
                                    this.Species6.Enabled = true;
                                    this.Species6.SelectedIndex = (int)(currentpokes[5, 4]) + (((int)(currentpokes[5, 5] & 1)) << 8);
                                    AddPokemonForms(5, this.Species6.SelectedIndex, this.PForm6, currentpokes[5, 5] >> 2);

                                    if ((int)this.Type.Value % 2 == 1)
                                    {
                                        this.Attack61.Enabled = true;
                                        this.Attack62.Enabled = true;
                                        this.Attack63.Enabled = true;
                                        this.Attack64.Enabled = true;
                                        this.Attack61.SelectedIndex = (int)(currentpokes[5, 6 + (int)this.Type.Value - 1]) + (((int)(currentpokes[5, 7 + (int)this.Type.Value - 1])) << 8);
                                        this.Attack62.SelectedIndex = (int)(currentpokes[5, 8 + (int)this.Type.Value - 1]) + (((int)(currentpokes[5, 9 + (int)this.Type.Value - 1])) << 8);
                                        this.Attack63.SelectedIndex = (int)(currentpokes[5, 10 + (int)this.Type.Value - 1]) + (((int)(currentpokes[5, 11 + (int)this.Type.Value - 1])) << 8);
                                        this.Attack64.SelectedIndex = (int)(currentpokes[5, 12 + (int)this.Type.Value - 1]) + (((int)(currentpokes[5, 13 + (int)this.Type.Value - 1])) << 8);

                                        if ((int)this.Type.Value == 3)
                                        {
                                            this.PItem6.Enabled = true;
                                            this.PItem6.SelectedIndex = (int)(currentpokes[5, 6]) + (((int)(currentpokes[5, 7])) << 8);
                                        }

                                    }
                                    else if ((int)this.Type.Value == 2)
                                    {
                                        this.PItem6.Enabled = true;
                                        this.PItem6.SelectedIndex = (int)(currentpokes[5, 6]) + (((int)(currentpokes[5, 7])) << 8);
                                    }
                                }
                            }
                        }

                    }

                }

            }
        }// End GetCurrentPokes()

        private void AddPokemonForms(int p, int num, ComboBox PForm, int formnum)
        {
            if (this.Game.SelectedIndex == 1) // Platinum 
            {
                PForm.Items.Clear();
                
                switch (num)
                {
                    case 201: // Unown

                        PForm.Enabled = true;
                        PForm.Items.Add("A");
                        PForm.Items.Add("B");
                        PForm.Items.Add("C");
                        PForm.Items.Add("D");
                        PForm.Items.Add("E");
                        PForm.Items.Add("F");
                        PForm.Items.Add("G");
                        PForm.Items.Add("H");
                        PForm.Items.Add("I");
                        PForm.Items.Add("J");
                        PForm.Items.Add("K");
                        PForm.Items.Add("L");
                        PForm.Items.Add("M");
                        PForm.Items.Add("N");
                        PForm.Items.Add("O");
                        PForm.Items.Add("P");
                        PForm.Items.Add("Q");
                        PForm.Items.Add("R");
                        PForm.Items.Add("S");
                        PForm.Items.Add("T");
                        PForm.Items.Add("U");
                        PForm.Items.Add("V");
                        PForm.Items.Add("W");
                        PForm.Items.Add("X");
                        PForm.Items.Add("Y");
                        PForm.Items.Add("Z");
                        PForm.Items.Add("!");
                        PForm.Items.Add("?");

                        if (formnum < 28)
                        {
                            PForm.SelectedIndex = formnum;
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 386: // Deoxys

                        PForm.Enabled = true;
                        PForm.Items.Add("Normal");
                        PForm.Items.Add("Attack");
                        PForm.Items.Add("Defense");
                        PForm.Items.Add("Speed");

                        if (formnum < 4)
                        {
                            PForm.SelectedIndex = formnum;
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;


                    case 412: // Burmy
                    case 413: // Wormadam

                        PForm.Enabled = true;
                        PForm.Items.Add("Plant");
                        PForm.Items.Add("Sand");
                        PForm.Items.Add("Trash");

                        if (formnum < 3)
                        {
                            PForm.SelectedIndex = (formnum);
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 422: // Shellos
                    case 423: // Gastrodon

                        PForm.Enabled = true;
                        PForm.Items.Add("West");
                        PForm.Items.Add("East");

                        if (formnum < 2)
                        {
                            PForm.SelectedIndex = formnum;
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 479: // Rotom

                        PForm.Enabled = true;
                        PForm.Items.Add("Normal");
                        PForm.Items.Add("Heat");
                        PForm.Items.Add("Wash");
                        PForm.Items.Add("Frost");
                        PForm.Items.Add("Spin");
                        PForm.Items.Add("Cut");

                        if (formnum < 6)
                        {
                            PForm.SelectedIndex = formnum;
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }
                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 487: // Giratina

                        PForm.Enabled = true;
                        PForm.Items.Add("Altered");
                        PForm.Items.Add("Origin");

                        if (formnum < 2)
                        {
                            PForm.SelectedIndex = (formnum);
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 492: // Shaymin

                        PForm.Enabled = true;
                        PForm.Items.Add("Land");
                        PForm.Items.Add("Sky");

                        if (formnum < 2)
                        {
                            PForm.SelectedIndex = (formnum);
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;

                    case 493: // Arceus

                        PForm.Enabled = true;
                        PForm.Items.Add("Normal");
                        PForm.Items.Add("Fighting");
                        PForm.Items.Add("Flying");
                        PForm.Items.Add("Poison");
                        PForm.Items.Add("Ground");
                        PForm.Items.Add("Rock");
                        PForm.Items.Add("Bug");
                        PForm.Items.Add("Ghost");
                        PForm.Items.Add("Steel");
                        PForm.Items.Add("???");
                        PForm.Items.Add("Fire");
                        PForm.Items.Add("Water");
                        PForm.Items.Add("Grass");
                        PForm.Items.Add("Electric");
                        PForm.Items.Add("Psychic");
                        PForm.Items.Add("Ice");
                        PForm.Items.Add("Dragon");
                        PForm.Items.Add("Dark");

                        if (formnum < 18)
                        {
                            PForm.SelectedIndex = (formnum);
                        }
                        else
                        {
                            PForm.SelectedIndex = 0;
                        }

                        currentpokes[p, 5] |= (byte)(PForm.SelectedIndex << 2);
                        break;
                
                    default:

                        if (PForm.Enabled)
                        {
                            PForm.Enabled = false;
                        }

                        currentpokes[p, 5] &= 1;
                        break;
                }
            }
        }

        private void TrainerClass_SelectedIndexChanged(object sender, EventArgs e)
        {
            currenttrainer[1] = (byte)this.TrainerClass.SelectedIndex;
        }

        private void IsDoubleBattle_CheckedChanged(object sender, EventArgs e)
        {
            if (this.IsDoubleBattle.Checked == false)
            {
                currenttrainer[0x10] = 0;
            }
            else
            {
                currenttrainer[0x10] = 2;
            }
        }

        private void Item_IndexChanged(ComboBox Item)
        {
            byte index;
            Byte.TryParse(Item.Name.Substring(Item.Name.Length - 1, 1), out index);

            if (index > 0)
            {
                index--;
            }

            currenttrainer[(index * 2) + 4] = (byte)(Item.SelectedIndex & 0xFF);
            currenttrainer[(index * 2) + 5] = (byte)((Item.SelectedIndex & 0xFF00) >> 8);

        }

        private void Item1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Item_IndexChanged(this.Item1);
        }

        private void Item2_SelectedIndexChanged(object sender, EventArgs e)
        {
            Item_IndexChanged(this.Item2);
        }

        private void Item3_SelectedIndexChanged(object sender, EventArgs e)
        {
            Item_IndexChanged(this.Item3);
        }

        private void Item4_SelectedIndexChanged(object sender, EventArgs e)
        {
            Item_IndexChanged(this.Item4);
        }

        private void Species_IndexChanged(ComboBox Species, ComboBox PForm)
        {
            byte index;
            Byte.TryParse(Species.Name.Substring(Species.Name.Length - 1, 1), out index);

            if (index > 0)
            {
                index--;
            }

            if (Species.Enabled)
            {
                currentpokes[index, 4] = (byte)(Species.SelectedIndex & 0xFF);
                byte form = (byte)(currentpokes[index, 5] & 0xFC);
                currentpokes[index, 5] = (byte)(((Species.SelectedIndex & 0xFF00) >> 8) & 1);
                AddPokemonForms(index, Species.SelectedIndex, PForm, form >> 2);
            }

        }

        private void Species1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species1, this.PForm1);
        }

        private void Species2_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species2, this.PForm2);
        }

        private void Species3_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species3, this.PForm3);
        }

        private void Species4_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species4, this.PForm4);
        }

        private void Species5_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species5, this.PForm5);
        }

        private void Species6_SelectedIndexChanged(object sender, EventArgs e)
        {
            Species_IndexChanged(this.Species6, this.PForm6);
        }

        private void PItem_IndexChanged(ComboBox PItem)
        {
            byte index;
            Byte.TryParse(PItem.Name.Substring(PItem.Name.Length - 1, 1), out index);

            if (index > 0)
            {
                index--;
            }

            if (PItem.Enabled)
            {
                currentpokes[index, 6] = (byte)(PItem.SelectedIndex & 0xFF);
                currentpokes[index, 7] = (byte)((PItem.SelectedIndex & 0xFF00) >> 8);
            }

        }

        private void PItem1_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem1);
        }

        private void PItem2_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem2);
        }

        private void PItem3_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem3);
        }

        private void PItem4_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem4);
        }

        private void PItem5_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem5);
        }

        private void PItem6_SelectedIndexChanged(object sender, EventArgs e)
        {
            PItem_IndexChanged(this.PItem6);

        }

        private void Attack_IndexChanged(ComboBox Attack)
        {
            if (Attack.Enabled)
            {
                byte index;
                byte attacknum;

                Byte.TryParse(Attack.Name.Substring(Attack.Name.Length - 2, 1), out index);
                Byte.TryParse(Attack.Name.Substring(Attack.Name.Length - 1, 1), out attacknum);

                if (index > 0)
                {
                    index--;
                }

                if (attacknum > 0)
                {
                    attacknum--;
                }

                if (currenttype == 0 || currenttype == 3)
                {
                    currentpokes[index, 8 + attacknum * 2] = (byte)(Attack.SelectedIndex & 0xFF);
                    currentpokes[index, 9 + attacknum * 2] = (byte)((Attack.SelectedIndex & 0xFF00) >> 8);
                }
                else
                {
                    currentpokes[index, 6 + attacknum * 2] = (byte)(Attack.SelectedIndex & 0xFF);
                    currentpokes[index, 7 + attacknum * 2] = (byte)((Attack.SelectedIndex & 0xFF00) >> 8);
                }
            }

        }

        private void Attack11_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack11);
        }

        private void Attack21_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack21);
        }

        private void Attack31_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack31);
        }

        private void Attack41_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack41);
        }

        private void Attack51_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack51);
        }

        private void Attack61_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack61);
        }

        private void Attack12_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack12);
        }

        private void Attack22_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack22);
        }

        private void Attack32_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack32);
        }

        private void Attack42_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack42);
        }

        private void Attack52_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack52);
        }

        private void Attack62_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack62);
        }

        private void Attack13_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack13);
        }

        private void Attack23_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack23);
        }

        private void Attack33_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack33);
        }

        private void Attack43_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack43);
        }

        private void Attack53_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack53);
        }

        private void Attack63_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack63);
        }

        private void Attack14_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack14);
        }

        private void Attack24_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack24);
        }

        private void Attack34_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack34);
        }

        private void Attack44_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack44);
        }

        private void Attack54_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack54);
        }

        private void Attack64_SelectedIndexChanged(object sender, EventArgs e)
        {
            Attack_IndexChanged(this.Attack64);
        }

        private void PForm_IndexChanged(ComboBox PForm)
        {
            byte index;
            Byte.TryParse(PForm.Name.Substring(PForm.Name.Length - 1, 1), out index);

            if (index > 0)
            {
                index--;
            }

            if (PForm.Enabled)
            {
                currentpokes[index, 5] |= (byte)(PForm.SelectedIndex << 2);
            }

        }

        private void PForm1_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm1);
        }

        private void PForm2_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm2);
        }

        private void PForm3_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm3);
        }

        private void PForm4_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm4);
        }

        private void PForm5_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm5);
        }

        private void PForm6_SelectedIndexChanged(object sender, EventArgs e)
        {
            PForm_IndexChanged(this.PForm6);
        }

        private void SaveAll_Click(object sender, EventArgs e)
        {
            this.datanr.ReplaceEntry(this.TrainerID.SelectedIndex, 0x14, currenttrainer);
            int datasize = 0;

            switch ((int)this.Type.Value)
            {
                case 0:
                    datasize = 0x6;
                    break;

                case 1:
                    datasize = 0xE;
                    break;

                case 2:
                    datasize = 0x8;
                    break;

                case 3:
                    datasize = 0x10;
                    break;
            }

            if (this.Game.SelectedIndex == 1)
            {
                datasize += 2;
            }

            int size = (int)this.NumberPokemon.Value * datasize;
            byte[] outputpokes = new byte[size];
            for (int i = 0; i < (int)this.NumberPokemon.Value; i++)
            {
                for (int j = 0; j < datasize; j++)
                {
                    outputpokes[i * datasize + j] = currentpokes[i, j];
                }
            }
            this.pokenr.ReplaceEntry(this.TrainerID.SelectedIndex, size, outputpokes);

            if (size - oldsize < 0)
            {
                this.pokenr.DeleteFromEnd(oldsize - size);
                // MessageBox.Show(String.Format("Please delete {0}(0x{1:X}) bytes from the end of the file", oldsize - size, oldsize - size));
            }
        }

        private void Level_ValueChanged(NumericUpDown Level)
        {
            byte index;
            Byte.TryParse(Level.Name.Substring(Level.Name.Length - 1, 1), out index);

            if (index > 0)
            {
                index--;
            }

            if (Level.Enabled)
            {
                currentpokes[index, 2] = (byte)(Level.Value);
            }

        }

        private void Level1_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level1);
        }

        private void Level2_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level2);
        }

        private void Level3_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level3);
        }

        private void Level4_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level4);
        }

        private void Level5_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level5);
        }

        private void Level6_ValueChanged(object sender, EventArgs e)
        {
            Level_ValueChanged(this.Level6);
        }

        private void Type_ValueChanged(object sender, EventArgs e)
        {

            if (currenttype != (byte)Type.Value)
            {

                currenttrainer[0] = (byte)Type.Value;

                switch ((byte)Type.Value)
                {
                    case 0:
                    case 1:

                        if (currenttype >= 2)
                        {
                            for (int i = 0; i < 6; i++)
                            {
                                for (int j = 6; j < 0x10; j++)
                                {
                                    currentpokes[i, j] = currentpokes[i, j + 2];
                                }
                            }

                        }
                        break;

                    case 2:
                    case 3:
                        
                        if (currenttype <= 1)
                        {
                            for (int i = 0; i < 6; i++)
                            {
                                for (int j = 0x11; j >= 6; j--)
                                {
                                    currentpokes[i, j] = currentpokes[i, j - 2];
                                }
                                currentpokes[i, 6] = 0;
                                currentpokes[i, 7] = 0;
                            }
                        }
                        break;
                }

                currenttype = (byte)Type.Value;
                GetCurrentPokes();

            }

        }

        private void NumberPokemon_ValueChanged(object sender, EventArgs e)
        {
            IsDoubleBattle.Enabled = (byte)this.NumberPokemon.Value >= 2;
            currenttrainer[3] = (byte)this.NumberPokemon.Value;
            GetCurrentPokes();
        }

        private void UpDown_KeyUp(NumericUpDown UpDown)
        {
            // Hack: update UpDown Value if the user
            // types in something (rather than clicking the up/down buttons)
            decimal tmp = UpDown.Value;
        }

        private void Level1_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level1);
        }

        private void Level2_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level2);
        }

        private void Level3_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level3);
        }

        private void Level4_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level4);
        }

        private void Level5_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level5);
        }

        private void Level6_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Level6);
        }

        private void Type_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.Type);
        }

        private void NumberPokemon_KeyUp(object sender, KeyEventArgs e)
        {
            UpDown_KeyUp(this.NumberPokemon);
        }

        private void TrainerID_TextChanged(object sender, EventArgs e)
        {
            int index = this.TrainerID.FindStringExact(this.TrainerID.Text);

            if (!this.TrainerID.Text.Equals("") && index >= 0)
            {   
                this.SaveAll.Enabled = true;
                this.saveAllToolStripMenuItem.Enabled = true;
                this.TrainerID.SelectedIndex = index;
                this.TrainerID.SelectionStart = this.TrainerID.Text.Length;
                this.TrainerID.SelectionLength = 0;
            }
            else
            {
                this.SaveAll.Enabled = false;
                this.saveAllToolStripMenuItem.Enabled = false;
            }

        }

        private void Game_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (this.Game.SelectedIndex >= 0)
            {
                this.TrainerID.Enabled = pokedataloaded;
            }

        }


    }
}
