﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace PPTE
{
    public class NarcReader
    {
        public int Entries;
        public FileEntry[] fe;
        public FileStream fs;
        private string m_sFileName;
        public long size;

        public NarcReader(string strFileName)
        {
            this.m_sFileName = strFileName;
            this.fs = new FileStream(strFileName, FileMode.Open, FileAccess.ReadWrite);
            BinaryReader reader = new BinaryReader(this.fs);
            byte[] buffer = new byte[0x10];
            reader.Read(buffer, 0, 0x10);
            this.size = BitConverter.ToUInt32(buffer, 8);
            int num = BitConverter.ToInt16(buffer, 12);
            this.fs.Seek((long) num, SeekOrigin.Begin);
            buffer = new byte[12];
            reader.Read(buffer, 0, 12);
            int num2 = BitConverter.ToInt32(buffer, 4);
            this.Entries = BitConverter.ToInt32(buffer, 8);
            this.fe = new FileEntry[this.Entries];

            for (int i = 0; i < this.Entries; i++)
            {
                this.fe[i].Ofs = reader.ReadInt32();
                this.fe[i].Size = reader.ReadInt32() - this.fe[i].Ofs;
            }

            this.fs.Seek((long) (num + num2), SeekOrigin.Begin);
            buffer = new byte[0x10];
            reader.Read(buffer, 0, 0x10);
            int num3 = BitConverter.ToInt32(buffer, 4);
            num3 = ((num + num3) + num2) + 8;

            for (int j = 0; j < this.Entries; j++)
            {
                this.fe[j].Ofs += num3;
            }

            this.fs.Close();
        }

        public void Close()
        {
            this.fs.Close();
        }

        public int OpenEntry(int id)
        {
            this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
            this.fs.Seek((long) this.fe[id].Ofs, SeekOrigin.Begin);
            return 0;
        }

        public void ReplaceEntry(int index,int newsize, byte[] replacement)
        {
            int difference = newsize - this.fe[index].Size;
            this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
            this.fs.Seek(8, SeekOrigin.Begin);
            BinaryWriter writer = new BinaryWriter(this.fs);
            writer.Write((int)(this.size + difference));
            this.Close();

            if (difference > 0)
            {
                for (int i = this.Entries - 1; i > index; i--)
                {
                    this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                    this.fs.Seek((long)(this.fe[i].Ofs), SeekOrigin.Begin);
                    BinaryReader read = new BinaryReader(fs);
                    BinaryWriter write = new BinaryWriter(fs);
                    byte[] pokes = new byte[this.fe[i].Size];
                    read.Read(pokes, 0, this.fe[i].Size);
                    this.fs.Seek(-this.fe[i].Size+difference, SeekOrigin.Current);
                    write.Write(pokes,0,this.fe[i].Size);
                    this.fs.Close();

                }

                this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                this.fs.Seek((long)(this.fe[index].Ofs), SeekOrigin.Begin);
                BinaryWriter writer2 = new BinaryWriter(fs);
                writer2.Write(replacement);
                this.fs.Close();

                for (int j = index; j < this.Entries; j++)
                {
                    this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                    this.fs.Seek((long)(0x1C + j * 8), SeekOrigin.Begin);
                    BinaryWriter writer3 = new BinaryWriter(fs);
                    BinaryReader reader3 = new BinaryReader(fs);
                    
                    if (j == index)
                    {
                        fs.Seek(4, SeekOrigin.Current);
                        long nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        this.fe[index].Size += difference;
                        
                    }
                    else
                    {
                        long nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        this.fe[j].Ofs += difference;
                    }

                    this.fs.Close();
                }
            }
            else if (difference < 0)
            {
                for (int i = index+1; i < this.Entries; i++)
                {
                    this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                    this.fs.Seek((long)(this.fe[i].Ofs), SeekOrigin.Begin);
                    BinaryReader read = new BinaryReader(fs);
                    BinaryWriter write = new BinaryWriter(fs);
                    byte[] pokes = new byte[this.fe[i].Size];
                    read.Read(pokes, 0, this.fe[i].Size);
                    this.fs.Seek(-this.fe[i].Size + difference, SeekOrigin.Current);
                    write.Write(pokes, 0, this.fe[i].Size);
                    this.fs.Close();

                }
                
                this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                this.fs.Seek((long)(this.fe[index].Ofs), SeekOrigin.Begin);
                BinaryWriter writer2 = new BinaryWriter(fs);
                writer2.Write(replacement);
                this.fs.Close();

                for (int j = index; j < this.Entries; j++)
                {
                    this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                    this.fs.Seek((long)(0x1C + j * 8), SeekOrigin.Begin);
                    BinaryWriter writer3 = new BinaryWriter(fs);
                    BinaryReader reader3 = new BinaryReader(fs);
                
                    if (j == index)
                    {
                        fs.Seek(4, SeekOrigin.Current);
                        long nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        this.fe[index].Size += difference;
                    }
                    else
                    {
                        long nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        nsize = reader3.ReadUInt32();
                        fs.Seek(-4, SeekOrigin.Current);
                        writer3.Write((int)(nsize + difference));
                        this.fe[j].Ofs += difference;
                    }
                    
                    this.fs.Close();
                }
            }
            else
            {
                this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);
                this.fs.Seek((long)(this.fe[index].Ofs), SeekOrigin.Begin);
                BinaryWriter writer3 = new BinaryWriter(fs);
                writer3.Write(replacement);
                this.fs.Close();
            }

        }

        public void DeleteFromEnd(long size)
        {
            this.fs = new FileStream(this.m_sFileName, FileMode.Open, FileAccess.ReadWrite);

            if (fs.Length - size > 0)
            {
                this.fs.SetLength(fs.Length - size);
            }

            this.fs.Close();

        }

    }


}